using Adaptation.Shared;
using Adaptation.Shared.Methods;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Text.Json;

namespace _Tests.Extract.Staging.v2_39_0;

[TestClass]
public class MET08DDUPSP1TBI
{

#pragma warning disable CA2254
#pragma warning disable IDE0060

    private static CreateSelfDescription.Staging.v2_39_0.MET08DDUPSP1TBI _MET08DDUPSP1TBI;

    [ClassInitialize]
    public static void ClassInitialize(TestContext testContext)
    {
        CreateSelfDescription.Staging.v2_39_0.MET08DDUPSP1TBI.ClassInitialize(testContext);
        _MET08DDUPSP1TBI = CreateSelfDescription.Staging.v2_39_0.MET08DDUPSP1TBI.EAFLoggingUnitTesting;
    }

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI637710931421087642__Normal()
    {
        string check = "~IsXToOpenInsightMetrologyViewer";
        MethodBase methodBase = new StackFrame().GetMethod();
        _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI();
        string[] variables = _MET08DDUPSP1TBI.AdaptationTesting.GetVariables(methodBase, check);
        Tuple<string, string[], string[]> pdsf = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _MET08DDUPSP1TBI.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Tuple<string, Test[], JsonElement[], List<FileInfo>> extractResult = fileRead.ReExtract();
        Assert.IsFalse(string.IsNullOrEmpty(extractResult?.Item1));
        Assert.IsTrue(extractResult.Item3.Length > 0, "extractResult Array Length check!");
        Assert.IsNotNull(extractResult.Item4);
        Logistics logistics = new(fileRead);
        Tuple<string, string[], string[]> pdsfNew = Helpers.Metrology.GetLogisticsColumnsAndBody(fileRead, logistics, extractResult, pdsf);
        Helpers.Metrology.CompareSave(variables[5], pdsf, pdsfNew);
        Assert.IsTrue(pdsf.Item1 == pdsfNew.Item1, "Item1 check!");
        string[] json = Helpers.Metrology.GetItem2(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveJSON(variables[5], json);
        Assert.IsTrue(json[0] == json[1], "Item2 check!");
        string[] join = Helpers.Metrology.GetItem3(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveTSV(variables[5], join);
        Assert.IsTrue(join[0] == join[1], "Item3 (Join) check!");
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI_() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI_();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI__() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI__();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI___() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI___();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI____() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI____();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI_____() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI_____();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI______() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI______();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI_______() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI_______();

    [TestMethod]
    public void Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI________() => _MET08DDUPSP1TBI.Staging__v2_39_0__MET08DDUPSP1TBI__MET08DDUPSP1TBI________();

}